signature OLD_EM_ELIMINATION = sig
  include PASS
  val dbg : bool ref
end
structure OldEMElimination :> OLD_EM_ELIMINATION =
  struct
    structure T = SMLNG
    structure C = Context
    val {dbg,dsay,ddoc,derr} = Debug.mk()
    val name = "old-em-elimination"
    fun go doc = let
      
      fun kSeq(x,y) = T.Seq(x,y)
	
      fun kTxt(c,s) =
	if Context.Get.em c then T.Nd(T.EM, (T.Txt s))
	else (T.Txt s)

      fun kWs(c,s) = (T.Ws s)

      fun kNd(c,T.EM,d) = d
       |  kNd(c,T.S,d) =  
          if Context.Get.s c then d
          else T.Nd(T.S,d) 
       |  kNd(c,t,d)= T.Nd(t,d)
      val doc' =
	Context.fold_with_ctxt 
	{kSeq=kSeq, kTxt=kTxt, kWs=kWs, kNd=kNd} Context.init doc
    in doc'
    end
  (* share tests with the other em elimination module *)
    val tests = Tests.mk name false go EMElimination.em_tests

  end
