signature ST_MONAD =  sig
  end
structure StateMonad
 datatype ('a,'b) S = S of 'a -> ('b * 'a)
    fun eval (S m) s = m s
    fun ret v = S (fn s => (v,s))
    fun bnd m f = S (fn s => let
		     val (v,s) = eval m s
		     in eval (f v) s
		     end)

    (* operations on the state *)
    fun bndS m f = S (fn s => let
		       val (v,s) = eval m s
		       in eval (f (v,s)) s
		      end)
    fun setS s' m = S (fn s => let
		      val (v,_) = eval m s
		      in (v,s')
		      end)
